// SPDX-FileCopyrightText: 2023, Yaskawa America, Inc.
// SPDX-FileCopyrightText: 2023, Delft University of Technology
//
// SPDX-License-Identifier: BSD-3-Clause

#ifndef MOTOPLUS_LIBMICROROS_CONFIG_H
#define MOTOPLUS_LIBMICROROS_CONFIG_H


// build env defines
#define YASKAWA_MOTOMAN_MOTOPLUS1_GCC43
#define YASKAWA_MOTOMAN_MOTOPLUS1

// only the '#define'd platform is supported by this distribution
/* #undef MOTOPLUS_LIBMICROROS_PLATFORM_DX200 */
/* #undef MOTOPLUS_LIBMICROROS_PLATFORM_FS100 */
#define MOTOPLUS_LIBMICROROS_PLATFORM_YRC1000
/* #undef MOTOPLUS_LIBMICROROS_PLATFORM_YRC1000u */

// make sure at least one platform is configured
#if !defined(MOTOPLUS_LIBMICROROS_PLATFORM_DX200) \
 && !defined(MOTOPLUS_LIBMICROROS_PLATFORM_FS100) \
 && !defined(MOTOPLUS_LIBMICROROS_PLATFORM_YRC1000) \
 && !defined(MOTOPLUS_LIBMICROROS_PLATFORM_YRC1000u)
#error "Invalid MotoPlus libmicroros configuration: unsupported platform"
#endif

// check consistency of M+ libmicroros and M+ SDK target
#if defined(MOTOPLUS_LIBMICROROS_PLATFORM_DX200) && !defined(DX200)
#error "Wrong libmicroros platform: only compatible with 'DX200' M+ SDK target"
#endif
#if defined(MOTOPLUS_LIBMICROROS_PLATFORM_FS100) && !defined(FS100)
#error "Wrong libmicroros platform: only compatible with 'FS100' M+ SDK target"
#endif
#if defined(MOTOPLUS_LIBMICROROS_PLATFORM_YRC1000) && !defined(YRC1000)
#error "Wrong libmicroros platform: only compatible with 'YRC1000' M+ SDK target"
#endif
#if defined(MOTOPLUS_LIBMICROROS_PLATFORM_YRC1000u) && !defined(YRC1000u)
#error "Wrong libmicroros platform: only compatible with 'YRC1000u' M+ SDK target"
#endif

// Define the M+ libmicroros version string
#define MOTOPLUS_LIBMICROROS_VERSION_STR "iron-20240327-rc0"

// Store the supported ROS 2 version (codename only)
#define MOTOPLUS_LIBMICROROS_ROS2_CODENAME "iron"

// Only the '#define'd ROS2 version is supported by this distribution
/* #undef MOTOPLUS_LIBMICROROS_ROS2_IS_HUMBLE */
#define MOTOPLUS_LIBMICROROS_ROS2_IS_IRON

// rcl settings
#define RCL_COMMAND_LINE_ENABLED
#define RCL_LOGGING_ENABLED


#endif // MOTOPLUS_LIBMICROROS_CONFIG_H
